const register = require('../src/identityprovider/static/identityprovider/js/webauthn/register.js');

test('No document cookie returns null', () => {
    // TODO: There must be a better way of setting up the document mock
    // so we don't have to pass configurable=true
    Object.defineProperty(document, 'cookie', {
        get: jest.fn().mockImplementation(() => { return null; }),
        set: jest.fn().mockImplementation(() => {}),
        configurable: true
    });
    expect(register.getCookie('foo')).toBeNull();

});
test('Blank document cookie returns null', () => {
    Object.defineProperty(document, 'cookie', {
        get: jest.fn().mockImplementation(() => { return ''; }),
        set: jest.fn().mockImplementation(() => {}),
        configurable: true
    });
    expect(register.getCookie('foo')).toBeNull();

});

test('Cookie returns null if wanted value not present', () => {
    Object.defineProperty(document, 'cookie', {
        get: jest.fn().mockImplementation(() => { return 'bar=foo;'; }),
        set: jest.fn().mockImplementation(() => {}),
        configurable: true
    });
    expect(register.getCookie('foo')).toBeNull();

});

test('Cookie returns the value we are looking for', () => {
    Object.defineProperty(document, 'cookie', {
        get: jest.fn().mockImplementation(() => { return 'foo=bar;'; }),
        set: jest.fn().mockImplementation(() => {}),
        configurable: true
    });
    expect(register.getCookie('foo')).toBe('bar');

});
