#!/usr/bin/env python
from urlparse import urlparse

from conn_check_configs.django import (
    EXTRA_CHECK_MAKERS,
    STATSD_CHECK,
    run
)

STATSD_CHECK['send'] = 'Hakuna'
STATSD_CHECK['expect'] = 'Matata'


def make_recaptcha_v2_check(settings, options):
    check = {
        'type': 'https',
        'url': settings['CAPTCHA_V2_VERIFY_URL'],
        'method': 'GET',
        'expected_code': 200,
    }
    proxy = settings.get('CAPTCHA_PROXIES', {}).get('https')
    if proxy:
        proxy_host, proxy_port = urlparse(proxy).netloc.split(':')
        if proxy_host:
            check['proxy_host'] = proxy_host
        if proxy_port:
            check['proxy_port'] = int(proxy_port)

    return [check]


EXTRA_CHECK_MAKERS.append(make_recaptcha_v2_check)


if __name__ == '__main__':
    run()
