# Copyright 2010 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

# We use Django forms for webservice input validation

from __future__ import unicode_literals

from django.forms import fields

from identityprovider.forms import NewAccountForm


class WebserviceCreateAccountForm(NewAccountForm):
    remote_ip = fields.CharField(max_length=256)
    platform = fields.TypedChoiceField(choices=[
        ('web', 'Web'), ('desktop', 'Desktop'), ('mobile', 'Mobile')],
        empty_value='desktop', required=False)
    validate_redirect_to = fields.CharField(required=False)

    def __init__(self, *args, **kwargs):
        if args:
            data = args[0]
            if 'passwordconfirm' not in data:
                data['passwordconfirm'] = data['password']
        super(WebserviceCreateAccountForm, self).__init__(*args, **kwargs)
        # back fields optional for backwards compatibility
        self.fields['displayname'].required = False
        self.fields['accept_tos'].required = False

    def clean_validate_redirect_to(self):
        validate_redirect_to = self.cleaned_data.get('validate_redirect_to')
        # return None instead of '' as the default value
        if not validate_redirect_to:
            validate_redirect_to = None
        return validate_redirect_to
