from identityprovider.tests.helpers import FunctionalTestCase


class PrefilledEmailTestCase(FunctionalTestCase):
    """Pre-fill e-mail addresses on forms.

    If the user has attempted a login (and failed), we would like to use the
    e-mail provided to pre-fill other forms.

    """

    def test_forgot_password(self):
        """Forgot Password form."""
        response = self.login(email=self.new_email)

        email = self.get_attribute_from_response(
            response, 'input[name="email"]', 'value')
        link = self.get_attribute_from_response(
            response, 'input[name="forgot_password"]', 'formaction')

        response = self.client.post(
            link, data={'email': email, 'forgot_password': ''})
        email_field = self.get_from_response(response, 'input[name="email"]')
        self.assertEqual(email_field[0].get('value'), self.new_email)
